
c=====================================================================
c This progam has been designed to transform a file in the GEISA
c database format, into a file in the HITRAN database format
c Having started the program, after compilation, the user will be
c prompted to type in names of the GEISA format data file (120 columns)
c used as in put for this program, as well as the name of the output:
c the HITRAN format file.
c If the program terminated successfully, the user sees the system
c message: 'ALL DONE'
c====================================================================
c Program written at LTS, in Tomsk, Russia
c Updated February 23, 1998
c Updated April 23, 1999
c Updated March 21, 2000 : level N 79 was added to class 6 (for H2O)
c Updated March 23, 2001 : excluding molecules with HT codes > 35
c ===================================================================
c        Block-by-block reading of files
c        GEISA => HITRAN transformation program
c        UNIX VERSION
      CHARACTER*80 STROKA, FNAME,SCommand,DirCom,OutH
	CHARACTER*2 Ver
	Character*1 Char
	INTEGER*2 NCan
	INTEGER*4 FSize, PcHSize,PcGSize,UnHSize,UnGSize,I7
	INTEGER*4 MaxLine, NLines
	CHARACTER*121 GSLINES(260)   ! 121 for UNIX
      CHARACTER*101 HTLINES(260)   ! 101 for UNIX
	PARAMETER (NMOL=35,NTRANS=51,NCHOIC=10)
      INTEGER*2   NMOL5,IGMOL,IGISO
      CHARACTER*6 MOLID
      CHARACTER*9 VIB
      COMMON/MOLNAM/MOLID(0:NMOL)
      COMMON/CVIB/ VIB(15,250)
      COMMON/VIB/ ICLASS(NMOL),NCLASS(15)
	COMMON/MOL/ NMOL5,IGMOL(35), IGISO(35,10)
    	Common /reg1/SCommand,DirCom,ver
	Common /reg2/PcHSize,PcGSize,UnHSize,UnGSize,MaxLine
	Common /reg3/ GSLINES, HTLINES
	Common /reg4/I7
	Common/Char1/Char

C      ***  SET UP PARAMETERS ***
C
      Scommand='clear' ! clear for Unix
	DirCom='ls -l'   ! ls -l for Unix
	ver='UN'       ! UN for UNIX
        PcGSize=122
	UnGSize=PcGSize-1
	PcHSize=102
	UnHSize=PcHSize-1
	MaxLine=260
	I7=0
	Nmol5=Nmol
	Char='N'
	Print *, 'Type in the GEISA data file name'
	Read(*,*) FName
	Print *, 'Type in the HITRAN output file name'
	Read(*,*) OutH
	Call SYSTEM(SCommand)
c      if (ver.EQ.'PC') then
c	    Call PCSizeofFile(FName,FSize)
c	    NLINES=FSize/PCGSize
c     end if
c	if (ver.EQ.'UN') then
c	    Call UNSizeofFile(FName,FSize)
c	    NLINES=FSize/UNGSize
c      end if
c
c
      FSize=8534372       ! Input here the GEISA format file size (in bytes)
      NLINES=FSize/UNGSize
      Print *, 'Total number of lines: ',Nlines
	CALL REFORMATION(FName,OutH,NLINES)
	Print *,'  '
	Print *,' A L L  D O N E !!!'
	STOP
	END

C
      BLOCK DATA
C
C**************************************
C
      PARAMETER (NMOL=35,NTRANS=51,NCHOIC=10)
      CHARACTER*6 MOLID
      CHARACTER*9 VIB
	Integer*2 NMOL5,IGMOL,IGISO
      COMMON/MOLNAM/MOLID(0:NMOL)
      COMMON/CVIB/ VIB(15,250)
      COMMON/VIB/ ICLASS(NMOL),NCLASS(15)
	Common/MOL/ NMOL5,IGMOL(35),IGISO(35,10)
      DATA (MOLID(I),I=0,NMOL)/ 'All',
     1  'H2O',  'CO2',   'O3',  'N2O',   'CO',  'CH4',   'O2',
     2   'NO',  'SO2',  'NO2',  'NH3', 'HNO3',   'OH',   'HF',
     3  'HCl',  'HBr',   'HI',  'ClO',  'OCS', 'H2CO', 'HOCl',
     4   'N2',  'HCN','CH3Cl', 'H2O2', 'C2H2', 'C2H6',  'PH3',
     5  'COF2','SF6','H2S', 'HCOOH','HO2','O','ClONO2'/
C
C...Vibrational levels of each class of molecule in database:
C    CO, HF, HCl, HBr, HI, N2
      DATA (VIB(1,I),I=1,22)/
     +'        0','        1','        2','        3','        4',
     +'        5','         ','        6','        7','        8',
     +'        9','       10','       11','       12','       13',
     +'       14','       15','       16','       17','       18',
     +'       19','       20'  /
C
C    O2
      DATA (VIB(2,I),I=1,29)/
     +'       X0','       X1','       a0','       a1','       b0',
     +'       b1','       b2','         ','       X2','       B0',
     +'       B1','       B2','       B3','       B4','       B5',
     +'       B6','       B7','       B8','       B9','      B10',
     +'      B11','      B12','      B13','      B14','      B15',
     +'      B16','      B17','      B18','      B19' /
C
C    NO, OH, ClO
      DATA (VIB(3,I),I=1,30)/
     +' X3/2   0',' X3/2   1',' X3/2   2',' X3/2   3',' X3/2   4',
     +' X3/2   5',' X3/2   6',' X3/2   7',' X3/2   8',' X3/2   9',
     +' X1/2   0',' X1/2   1',' X1/2   2',' X1/2   3',' X1/2   4',
     +' X1/2   5',' X1/2   6',' X1/2   7',' X1/2   8',' X1/2   9',
     +' X3/2  10',' X3/2  11',' X3/2  12',' X3/2  13',' X3/2  14',
     +' X1/2  10',' X1/2  11',' X1/2  12',' X1/2  13',' X1/2  14'/
C
C    N2O, OCS, HCN
      DATA (VIB(4,I),I=1,55)/
     +'     0000','     0110','     0200','     0220','     1000',
     +'     0310','     0330','     1110','     0400','     0420',
     +'     1200','     1210','     2000','     0001','     0510',
     +'     1310','     1330','     2110','     0111','     1400',
     +'     1420','     2200','     2220','     3000','     0201',
     +'     0221','     1001','     2310','     3110','     0311',
     +'     0331','     1111','     4000','     3200','     2001',
     +'     1201','     1211','     0002','     2111','     0112',
     +'         ','     0600','     0620','     0202','     0222',
     +'     1220','     0530','     1510','     0440','     0441',
     +'     0421','     0401','     1221','     2400','     1002' /
C
C    CO2
      DATA (VIB(5,I),I=1,60)/
     +'    00001','    01101','    10002','    02201','    10001',
     +'    11102','    03301','    11101','    00011','    20003',
     +'    12202','    20002','    04401','    12201','    20001',
     +'    01111','    21103','    13302','    21102','    05501',
     +'    13301','    21101','    10012','    02211','    10011',
     +'    30004','    22203','    14402','    30003','    22202',
     +'    06601','    30002','    14401','    22201','    30001',
     +'    11112','    03311','    11111','    00021','    31104',
     +'    31103','    31102','    20013','    12212','    23301',
     +'    31101','    04411','    20012','    12211','    20011',
     +'    01121','    40004','    32203','    21113','    40002',
     +'    13312','    05511','    21112','    13311','    21111'/
      DATA (VIB(5,I),I=61,134)/
     +'    10022','    02221','    10021','    30014','    22213',
     +'    14412','    41102','    30013','    06611','    22212',
     +'    30012','    41101','    14411','    22211','    30011',
     +'    11122','    03321','    11121','    00031','    31114',
     + '   23313','    31113','    23312','    31112','    15511',
     +'    20023','    23311','    12222','    31111','    20022',
     +'    12221','    20021','    01131','    40015','    32214',
     +'    40014','    32213','    40013','    51102','    32212',
     +'    40012','    21123','    32211','    21122','    40011',
     +'    21121','    10032','    02231','    10031','    41114',
     +'    41113','    41112','    11132','    03331','    11131',
     +'    20033','    12232','    20032','    12231','    20031',
     +'    21133','    21132','    21131','    23303','    15502',
     +'    23302','    07701','         ','    00041','    00051',
     +'    01141','    10041','    10042','    02241'/
C
C    H2O, O3, SO2, NO2, HOCl, H2S, HO2
      DATA (VIB(6,I),I=1,78)/
     +'      000','      010','      020','      100','      001',
     +'      030','      110','      011','      040','      120',
     +'      021','      200','      101','      002','      130',
     +'      031','      210','      111','      012','      041',
     +'      220','      121','      022','      300','      201',
     +'      101','      003','      131','      310','      211',
     +'      112','      013','      141','      042','      320',
     +'      221','      301','      202','      121','      023',
     +'      400','      103','      004','      151','      330',
     +'      231','      212','      311','      410','      113',
     +'      321','      222','      302','      401','      420',
     +'      123','      500','      203','      104','         ',
     +'      331','      213','      312','      411','      303',
     +'      402','      403','      421','      501','      313',
     +'      412','      232','      050','      060','      070',
     +'      102','      021','      122'/
C
C    C2H2
      DATA (VIB(7,I),I=1,10)/
     +' 00000000',' 00000111',' 00100000',' 01011110',' 00011001',
     +'         ',' 00011110',' 00011112',' 00000200',' 00000222'/
C
C    NH3, PH3
      DATA (VIB(8,I),I=1,43)/
     +'    0000 ','    0100 ','    0200 ','    0001 ','    0000a',
     +'    0100a','    0200a','    0001a','    0000s','    0100s',
     +'    0200s','    0001s','         ','    0300s','    0101s',
     +'    0101a','    0300a','    0201s','   0002As','   0002Aa',
     +'   0002Es','   0002Ea','    1000s','    1000a','    0010s',
     +'    0010a','    0400s','    0201a','    0301s','    0400a',
     +'   0101As','   0101Es','   0101Aa','   0101Ea','    1100s',
     +'    1100a','    0110s','    0110a','    0301a','    1001s',
     +'    1001a','    0011s','    0011a' /
C
C    H2CO,H2O2,COF2
      DATA (VIB(9,I),I=1,15)/
     +'   000000','   000002','   001100','   001001','   100000',
     +'   000010','   010100','   010001','   000001','   010000',
     +'   000100','   020000','         ','   002001','   000020'/
C
C    CH4, CH3D, CH3Cl, C2H6, HNO3,  SF6, HCOOH, ClONO2
      DATA (VIB(10,I),I=1,53)/
     +' 00000000',' 00000111',' 01100001',' 00000202',' 00000222',
     +' 01100112',' 10000000',' 00011001',' 02200002',' 10000111',
     +' 00011112',' 01111002',' 00022002','   GROUND','       V1',
     +'       V2','       V4','       V5','       V9','      2V5',
     +'      2V9','      3V6','      3V9','    V5+V9','         ',
     +'       V6','       V3','      2V6',' 00000333',' 00011213',
     +'       V7','       V8','    V8+V9','    V3+V6','      2V3',
     +'    V5+V6','    V3+V5','    V4+V9',' 00 0 2  ',' 00 0 1  ',
     +' 00 0 3  ',' 01 0 2  ',' 01 0 0  ',' 01 0 1  ',' 02 0 1  ',
     +' 00 1 1  ',' 10 0 1  ',' 10 0 0  ',' 00 1 0  ',' 01 1 0  ',
     +' 02 0 0  ',' 11 0 0  ',' 03 0 0  '/
C
      DATA (VIB(11,I),I=1,250) /250*'         '/
      DATA (VIB(12,I),I=1,250) /250*'         '/
      DATA (VIB(13,I),I=1,250) /250*'         '/
      DATA (VIB(14,I),I=1,250) /250*'         '/
      DATA (VIB(15,I),I=1,250) /250*'         '/
C
C     Vibrational class of molecule:
      DATA (ICLASS(I),I=1,NMOL)/
C     H2O, CO2, O3, N2O, CO, CH4, O2, NO, SO2, NO2,
     +  6,   5,  6,   4,  1,  10,  2,  3,   6,   6,
C     NH3, HNO3, OH, HF, HCL, HBR, HI, CLO, OCS, H2CO,
     +  8,   10,  3,  1,   1,   1,  1,   3,   4,    9,
C     HOCl, N2, HCN, CH3Cl, H2O2, C2H2, C2H6, PH3
     +   6,  1,   4,    10,    9,    7,   10,   8,
C      COF2, SF6, H2S, HCOOH, HO2, O, CLONO2
     +   9,  10,   6,    10,   6,   1,   10/
C
C     Number of levels in each class:
C
      DATA (NCLASS(I),I=1,15)/22,29,30,55,134,78,10,43,15,53,0,0,0,0,0/
C
      DATA IGMOL/1,2,3,4,5,6,7,8,9,10,11,13,14,15,16,17,18,19,20,21,
     *32,33,27,34,35,24,22,12,38,39,36,37,41,43,42/
      DATA (IGISO(1,I),I=1,10)/161,181,171,162,182,172,4*0/
      DATA (IGISO(2,I),I=1,10)/626,636,628,627,638,637,828,728,838,0/
      DATA (IGISO(3,I),I=1,10)/666,668,686,667,676,5*0/
      DATA (IGISO(4,I),I=1,10)/446,456,546,448,447,5*0/
      DATA (IGISO(5,I),I=1,10)/26,36,28,27,38,37,4*0/
      DATA (IGISO(6,I),I=1,10)/211,311,212,7*0/
      DATA (IGISO(7,I),I=1,10)/66,68,67,7*0/
      DATA (IGISO(8,I),I=1,10)/46,56,48,7*0/
      DATA (IGISO(9,I),I=1,10) /626,646,8*0/
      DATA (IGISO(10,I),I=1,10)/646,9*0/
      DATA (IGISO(11,I),I=1,10)/411,511,8*0/
      DATA (IGISO(12,I),I=1,10)/146,9*0/
      DATA (IGISO(13,I),I=1,10)/61,81,62,7*0/
      DATA (IGISO(14,I),I=1,10)/19,9*0/
      DATA (IGISO(15,I),I=1,10)/15,17,8*0/
      DATA (IGISO(16,I),I=1,10)/19,11,8*0/
      DATA (IGISO(17,I),I=1,10)/17,9*0/
      DATA (IGISO(18,I),I=1,10)/56,76,8*0/
      DATA (IGISO(19,I),I=1,10)/622,624,632,623,822,5*0/
      DATA (IGISO(20,I),I=1,10)/126,136,128,7*0/
      DATA (IGISO(21,I),I=1,10)/165,167,8*0/
      DATA (IGISO(22,I),I=1,10)/44,9*0/
      DATA (IGISO(23,I),I=1,10)/124,134,125,7*0/
      DATA (IGISO(24,I),I=1,10)/215,217,8*0/
      DATA (IGISO(25,I),I=1,10)/166,9*0/
      DATA (IGISO(26,I),I=1,10)/221,231,8*0/
      DATA (IGISO(27,I),I=1,10)/226,9*0/
      DATA (IGISO(28,I),I=1,10)/131,9*0/
      DATA (IGISO(29,I),I=1,10)/269,9*0/
      DATA (IGISO(30,I),I=1,10)/29,9*0/
      DATA (IGISO(31,I),I=1,10)/121,141,131,7*0/
      DATA (IGISO(32,I),I=1,10)/261,9*0/
      DATA (IGISO(33,I),I=1,10)/166,9*0/
      DATA (IGISO(34,I),I=1,10)/6,9*0/
      DATA (IGISO(35,I),I=1,10)/564,764,8*0/
      END

c     SUBROUTINES and FUNCTIONS
c     **************************

      SUBROUTINE HT_Codes(GC,IGc,HC,iHc,HClass)
c      Obtain HITRAN codes (mol, isot, class)
      integer*2 GC,HC,Igc,iHc,HClass
      INTEGER*2   NMOL5,IGMOL,IGISO
      Common/MOL/ NMOL5,IGMOL(35),IGISO(35,10)
      COMMON/VIB/ ICLASS(35),NCLASS(15)
	HC=0
	ihc=0
	HClass=0
c     For CH3D
      if (GC.EQ.23) then
      HC=6
	go to 5
	end if
C   ---------------------------
	DO 10 i=1,NMOL5
	if (GC.EQ.IGmol(i)) then
	                  HC=i
					  go to 5
      end if
   10 CONTINUE
      RETURN
    5 HClass=IClass(HC)
      DO 200 i=1,10
c	if (IGISO(HC,i).EQ.0) go to 7
	if (IGISO(HC,i).EQ.igc) then
	     ihc=i
	     go to 7
      end if
  200 Continue
    7 Return
      End

	Subroutine DStr(N,S)
	Character*1 S
	Integer*2 N
	if (N.EQ.1) S='1'
	if (N.EQ.2) S='2'
	if (N.EQ.3) S='3'
	if (N.EQ.4) S='4'
	if (N.EQ.5) S='5'
	if (N.EQ.6) S='6'
	If (N.EQ.7) S='7'
	if (N.EQ.8) S='8'
	if (N.EQ.9) S='9'
	if (N.EQ.0) S='0'
	Return
	End

      Subroutine Str2(D,S)
c      Integer => Character*3 convertation (D <= 999 !)
	Integer*2 D,N1,N2,N3
	Character*3 S
	Character*1 S1,S2,S3
	if (D.GE.100) then
	N1=D/100
	N2=Mod(D/10,10)
	N3=Mod(D,100)
	Call DStr(N1,S1)
	Call DStr(N2,S2)
	Call DStr(N3,S3)
	S(1:1)=S1
	S(2:2)=S2
	S(3:3)=S3
	Return
	end if
	if (D.GE.10) then
	N1=D/10
	N2=Mod(D,10)
	Call Dstr(N1,S1)
	Call Dstr(N2,S2)
	S(1:1)=' '
	S(2:2)=S1
	S(3:3)=S2
	Return
	end if
	Call Dstr(D,S3)
	S(1:1)=' '
	S(2:2)=' '
	S(3:3)=S3
	Return
	End


      Subroutine Vibr(Class,UG,LG,UH,LH,RC)
	CHARACTER*9 UG,LG,Vib
	CHARACTER*3 UH,LH
	Integer*2 Class,NU,NL,RC
	Common/CVIB/VIB(15,250)
      Common/VIB/IClass(35), NClass(15)
        Rc=0
	nu=0
	nl=0
	do 10 i=1,NClass(Class)
	if (VIB(Class,i).EQ.UG) NU=i
	if (VIB(Class,i).EQ.LG) NL=i
	if (NL.NE.0.AND.NU.NE.0) go to 39
   10 Continue
C        Print *, '    *** Error !!! ***'
C	Print *, ' One of the following vibrational GEISA'
C	Print *, ' identifications is unknown:'
c	Print *, ' '
c	Print *,'   ',UG,'  **  ',LG
c	Print *,'You should add new identifications to '
c	Print *,'Vib(',Class,',i) array in Block Data.'
c	Print *,' '
c	Print *, ' The programm will be stoped'
c       Stop
c   39 Call Str1(nu,UH)
c      Call Str1(nl,LH)
      RC=1       ! if a new (unknown)level occurs
   39 Write(UH,'(I3)') nu
      Write(LH,'(I3)') nl
        Return
	End


      Subroutine TheSame(G,H,Hcl,Rc)
c       *** Copy the   same fields ***
c      Version for UNIX
	Character*121 G
	Character*101 H
	Character*3 Smol, Gisot1, CharHC, CharHI
	Character*5 SAir
	Integer*2 Hm,Hcl,Gcode,GIsot,HitCode, HitIsot
	Character*2 Gcode1
	Real*4 Freq, HAir
	Character*10 SFreq   ! Frequency in GEISA
	Character*12 HFreq   ! Frequency in HITRAN
	Character*1 Char
	Integer*2 Rc
      Common/VIB/ IClass(35), NClass(15)
	Common/Char1/Char
	Rc=0
	Smol=G(86:87)
	Read(Smol,'(I2)') Hm
	if (Hm.gt.Nmol) then
	                  Hcl=0
	                  go to 929
	endif
	Hcl=IClass(Hm)
929	if (Hcl.EQ.0) then
c      if Hitran data are missed...
	   Gisot1=G(77:79)
	   Read(Gisot1,'(I3)') Gisot ! Geisa isotop
	   GCode1=G(81:82)
	   Read(GCode1,'(I2)') GCode ! Geisa code
	   Call HT_Codes(GCode,GIsot,HitCode, HitIsot,Hcl)
c	   Call Str1(HitCode,CharHc)
c	   Call Str1(HitIsot,CharHi)
	   Write(CharHc,'(I3)') HitCode
	   Write(CharHi,'(I3)') HitIsot
	   H(1:2)=CharHc(2:3)  ! Hitran code
	   H(3:3)=CharHi(3:3)  ! Hitran isotop
	   if (Hcl.EQ.0) Rc=1
	   go to 33


	end if
c
        H(1:2)=G(86:87)      ! Molecular code
	H(3:3)=G(88:88)      ! Isotope code
c	H(4:13)=G(1:10)
   33	Sfreq=G(1:10)
	Read(SFreq,*) Freq
	HFreq(3:12)=SFreq(1:10)
	HFreq(1:1)=' '
	HFreq(2:2)=' '
      if (Freq.ge.10000.0) then
	   HFreq(1:10)=SFreq(1:10)
	   HFreq(11:11)='0'
	   HFreq(12:12)='0'
      end if
	if (Freq.ge.1000.0.and.Freq.lt.10000.0) then
	HFreq(1:1)=' '
	HFreq(2:11)=SFreq(1:10)
	HFReq(12:12)='0'
	end if
      H(4:15)=HFreq(1:12)       ! Frequency
      H(16:25)=G(11:20)    ! Intensity
	H(26:35)=G(89:98)    ! Transition probability
	SAir=G(21:25)
	Read(SAir,'(F5.3)') HAir
        if (HAir.ge.1.0) SAir=' .999' !maximum possible HW in HITRAN
c	if (HAir.ge.1.0) then
c	 if (Char.eq.'Y') go to 89
c	 Print *, 'Warning! The GEISA file has halfwidths > 1 cm-1'
c	 Print *, 'The information in the HITRAN file will be lost'
c      Print *, 'Ignore (Y/N)?'
c	 Read (*,*) Char
c	 if (Char.eq.'N'.or.Char.eq.'n') STOP
c	 Char='Y'
c	end if
   89 H(36:39)=SAir(2:5)    ! Air-broading
      H(40:40)='0'
	H(41:45)=G(99:103)   ! Self-broading
	H(46:55)=G(26:35)    ! Lower state energy
	DO 14 i=47,55
   14 H(I-1:I-1)=H(I:I)
      H(55:55)='0'
	H(56:59)=G(72:75)    ! Temperature coefficient
	H(60:67)=G(104:111)  ! Air-broadened pressure shift
c	H(68:73)=' RIEN '
	H(74:82)=G(54:62)    ! Upper rotational state
      H(83:91)=G(63:71)    ! Lower rotational state
	H(92:100)=G(112:120) ! References, accuracy
	H(101:101)=G(121:121)! End of line (1 symbol for UNIX !!!)
	Return
	End

	SUBROUTINE UN_GS_HT(G,H,N)
c        For UNIX
	CHARACTER*121 G(260)
	CHARACTER*101 H(260)
	CHARACTER*2 S2
	CHARACTER*3 HVup,HVlo
	Character*9 GVup,Gvlo
	INTEGER*4 N,I,I7
	Integer*2 GM,Gis,HM,HIs,Hcl,Rc
        Common /reg4/i7
	DO 10 i=1,N
	I7=I7+1
	if (MOD(I7,500).EQ.0) Print *, I7,' lines reformatted'
        
      Call TheSame(G(i),H(i),Hcl,Rc)
      if (RC.EQ.1) then
          Write(99,'(A120)') G(i)(1:120) ! lines of molecules which are absent in HITRAN
          H(I)(1:3)='ERR'
      end if
c      Convertation of vibrational quanta
      GVup=G(i)(36:44)
	Gvlo=G(i)(45:53)
c    In order to corriger 021 => 000 of O3
      if (Hcl.Eq.6) then
	       GVup(1:1)=' '
	       GVup(2:2)=' '
	       GVup(3:3)=' '
      end if
      Call Vibr(Hcl,GVup,GVlo,HVup,HVlo,RC)
        if (RC.EQ.1) then
          Write(99,'(A120)') G(i)(1:120) ! Unknown lines are directed to gs.err file
          H(I)(1:3)='ERR'
        end if
	H(i)(68:70)=HVup
	H(i)(71:73)=HVlo
   10 CONTINUE
      RETURN
	END


	SUBROUTINE REFORMATION(Name,NameH,N)
	Character*80 Name,NameH
	Integer*4 N,N1,NN,IRec
	CHARACTER*80 STROKA,SCommand,DirCom
 	CHARACTER*2 Ver
	INTEGER*4 FSize, PcHSize,PcGSize,UnHSize,UnGSize
	INTEGER*4 MaxLine,I,J,I7
	Integer*2 ReclH,ReclG
	CHARACTER*121 GSLINES(260)   ! 121 for UNIX
      CHARACTER*101 HTLINES(260)   ! 101 for UNIX
	Common /reg1/SCommand,DirCom,ver
	Common /reg2/PcHSize,PcGSize,UnHSize,UnGSize,MaxLine
	Common /reg3/ GSLINES, HTLINES
	Common /reg4/I7
	IRec=0
      N1=N/MaxLine
	NN=Mod(N,MaxLine)
	if (ver.EQ.'PC') then
	            ReclH=PCHSize*MaxLine
	            ReclG=PCGSize*MaxLine
      end if

	if (ver.EQ.'UN') then
	            ReclH=UNHSize*MaxLine
	            ReclG=UNGSize*MaxLine
      end if

        OPEN(99,file='gs.err',status='UNKNOWN')
	OPEN(30,File=Name,Status='OLD',FORM='UNFORMATTED',
     $Access='DIRECT',Recl=ReclG)
	OPEN(33,File=NameH,Status='NEW',FORM='UNFORMATTED',
     $Access='DIRECT',Recl=ReclH)
      DO 100 i=1,N1
      irec=irec+1
	READ(30,Rec=irec) GSLines
  	if (ver.EQ.'UN') Call UN_GS_HT(GSLines,HTLines,MaxLine)
      Write(33,Rec=irec) HTLines
  100	CONTINUE
      Close(30)
	Close(33)

c       *** Line-by-line reading the file
c
	if (ver.EQ.'PC') then
	            ReclH=PCHSize
	            ReclG=PCGSize
      end if
    	if (ver.EQ.'UN') then
	            ReclH=UNHSize
	            ReclG=UNGSize
      end if

      OPEN(30,File=Name,Status='OLD',FORM='UNFORMATTED',
     $Access='DIRECT',Recl=ReclG)
	OPEN(33,File=NameH,Status='OLD',FORM='UNFORMATTED',
     $Access='DIRECT',Recl=ReclH)
      irec=irec*MaxLine
c	Print *,irec,' entries have been read'
      DO 1000 i=1,NN
      irec=irec+1
	READ(30,Rec=irec) GSLines(1)
c	if (ver.EQ.'PC') Call PC_GS_HT(GSLines,HTLines,1)
	if (ver.EQ.'UN') Call UN_GS_HT(GSLines,HTLines,1)

  	Write(33,Rec=irec) HTLines(1)
 1000	CONTINUE
  333 Close(30)
	Close(33)
	Close(99)
	Return
	End







