#include "mystrings.h"
#include "constants.h"
class datamenager: public ifstream {
 public:   long   Nentries;  
           long   SizeofDatabase; 
           long   Nmbextr;
 protected: 
            int   DataSize, Nkeys;
           char * Datafilename;
           char * Bufer;
           char * Extrfilename;           
   //    istream  Fdb; 
        ofstream  Fout;
 public:
         datamenager(int,int,char *,char *); //constructor
//         datamenager(int,int,char *,char *,short ); 
         virtual void extr(long,long);             
         virtual char criterium(char *);
                                         
 

         ~datamenager();
                                   };
                                   
/*                       Members of datamenager            */
                                   
      datamenager::datamenager(int size,int key, char* name, char * outname) {
         long l,m; ldiv_t toto;
         
         Nmbextr=0;
         DataSize=size;
         Nkeys=key;
         Datafilename=name;
         Extrfilename=outname;
         Bufer= new char [DataSize];
         open(Datafilename,ios::in);
         if (! is_open())
             { cout << "Error opening database"; exit (1); }
         Fout.open(Extrfilename,ios::out);
         l=tellg();
         seekg(0,ios::end);
         m=tellg();
         SizeofDatabase=m-l;
         toto=ldiv(SizeofDatabase,DataSize);
         Nentries=toto.quot;
         seekg(0,ios::beg);  // do not forget !!!
                                                               }
                                                               
    void  datamenager::extr(long a,long b) {
     if ((a < 1) || (b >Nentries)) { cout << "Extr procedure error"; exit(1);}
         seekg((a-1)*DataSize,ios::beg); 
    for (long i=a; i<=b; i++) 
      { read(Bufer,DataSize);
          
     if (criterium(Bufer)){ Fout.write(Bufer,DataSize); Nmbextr++; }
      }    
         
    
                                           }  
                                                                                                          
    char  datamenager::criterium(char *) { return 1; }
       datamenager::~datamenager() { delete Bufer; Fout.close();}
       
 /*     ----- end of datamenager members  ------------------------------------ */
/*                                                        */
/*         Class gsmenager                               */   
  class gsmenager : public datamenager {
  public:  
          double F1,F2;   // from ... to (extraction)
          double First,Last;
          char   Form;
          
  public:
          gsmenager(int sz,char * nm1,char * nm2,double from, double to1):         
            datamenager(sz,11,nm1,nm2)
            { int l,m;
              F1=from;
              F2=to1;
              Form=0;  // format of output file: 0 -binary (default), 1- ASCII
 /*       Searching for database spectral limits */              
              seekg(0,ios::beg);
              read(Bufer,DataSize);
              memcpy(&First,Bufer,8);
              seekg((Nentries-1)*DataSize,ios::beg);
              read(Bufer,DataSize);
              memcpy(&Last,Bufer,8);
              close(); // close the database file
          
         open(Datafilename,ios::in); // open data base !!! do not forget !!  
          }
          
          virtual char criterium(char * ttt)
          
          { // double freq;
             //memcpy(&freq,ttt,8);
              
            // return ((freq >=F1)&& (freq<=F2)); 
            return 1;
          }         
          
          double frequency(long n)
            { double toto;
              seekg((n-1)*DataSize,ios::beg);
              read(Bufer,DataSize);
              memcpy(&toto,Bufer,8);
              return toto;
             }  
             
          long poselement(double F)
          { 
   //       if  ((F<First) || (F>Last))
    //        {
     //        cout << "Wavenumber is out of range: "<<First<<" - "<<Last ; exit(1); }
           if (F<First) F=First+0.0001;
           if (F>Last) F=Last-0.0001;
           long left1=1;
           long right1=Nentries;
           long ncurrent=ldiv(right1+left1,2).quot;
           float delta=frequency(ncurrent)-F;
           long idelta=right1-left1;
           while (idelta !=1) {
            if (delta > 0.0)  right1=ncurrent; 
                 else
                              left1=ncurrent;
           ncurrent=ldiv(right1+left1,2).quot;
           delta=frequency(ncurrent)-F;
           idelta=right1-left1;
                                          }
           double cfreq= frequency(ncurrent);
           if (cfreq > F2) ncurrent=ncurrent-1;
           if (cfreq <F1) ncurrent=ncurrent+1;                                         
           return ncurrent;
          }                                                  
                        
           void gextr()
         { extr(poselement(F1),poselement(F2)); }               
                        
          
  //       ~gsmenager() 
   //      {delete Molliste;}
          
                                        };
              
   /*      ----- End of gsmenager class ----------*/             
   /*                                                          */
   
   
   /*         ---- Class extrallbands  ---------- */
   
    class extrallbands : public gsmenager {
      public: 
                  short MolCodes[100];
                  int    NMolCodes;
      protected:  
                  
                 short * PMolCodes;
                 char *  Criterium;
      public:
                 
        
 extrallbands(int sz, char * nm1,char * nm2,double from1, double to1, char * crit1):
      gsmenager(sz,nm1,nm2,from1,to1)   
   {
         Criterium=crit1;
         F1=from1;
         F2=to1;
         PMolCodes=MolCodes; // it points to MolCodes
         StrInts(PMolCodes,NMolCodes,Criterium);
               

    }
    
    virtual char criterium(char * ttt)
    // for debugging only! A corriger.
              
              { short mis,ist; char m;
                if (MolCodes[0]==0) return 1; // if mole='all'
                memcpy(&ist,ttt+58,2);
                memcpy(&m,ttt+60,1);
                mis=m*1000+ist;
                for (int i=0; i<=NMolCodes-1; i++)
                 {  if (MolCodes[i] <0) 
                      if (m==-MolCodes[i]) return 1; // for molecules with all isotopes selected
                     if (MolCodes[i] > 0) 
                      if (mis==MolCodes[i]) return 1;
                  
                 }   
                
                return 0;
               }   
       void LesManip()
     { short mcopy[100];
       for (int i=0; i<=NMolCodes-1;i++)
         {if (MolCodes[i] > 1000) mcopy[i]=div(MolCodes[i],1000).quot;
                else mcopy[i]=MolCodes[i];
         }
         MolCodes[NMolCodes]=65500;
          for (int i=0; i<=NMolCodes-1;i++)
            { for (int j=i+1; j<=NMolCodes;j++)
                {                                        
               if (mcopy[i] == mcopy[j]) goto brk;   
                }
                if (i != 0) 
                 if (mcopy[i-1]==mcopy[i]) goto brk;
               mcopy[i]=-mcopy[i]; 
                
          brk: continue;   
                 
            }    
          for (int i=0; i<=NMolCodes-1; i++)
            {
               if (mcopy[i] <0) MolCodes[i]=-MolCodes[i];
            }         
                
      }           
                 
                 
                                         };            
/*            ------------- gsinfo class ---------------------------------*/

    class gsinfo: public gsmenager {
        protected: 
                   struct molinfo{ 
                      char molecule[MAXMOLNAMELENGTH];
                      long nmbtr;
                      float fmin,fmax;
                      double intmin,intmax;
                                 } infolist[MAXMOL] ;
                            
                    char * Molliste;
                    int    NMol;
                    char * Mfname;
         //           int    molnamelinesize; // 66 for UNIX, 67 for PC
                    
        public:
     gsinfo(int sz,char * nm1,char * molname, double from1,double to1):
       gsmenager(sz,nm1,NULL,from1,to1) {
         char BBF[90];
         F1=from1;
         F2=to1;  
         Mfname=molname;
         NMol=0;
  //       molnamelinesize=66; // 66 for UNIX, 67 for PC
         close(); // close the database file
   
   /*   Loading molecule names and initialization of counters   */
         
         open(Mfname,ios::in);
         if (! is_open())
             { cout << "Error opening molecular names&codes file"; exit (1); }
         while (! eof() )
          {
            getline(BBF,90);
            NMol++;
            memcpy(infolist[NMol].molecule,BBF,6);
            infolist[NMol].molecule[6]='\0';
            infolist[NMol].nmbtr=0;
            infolist[NMol].fmin=1000000.0;
            infolist[NMol].fmax=-1.0;
            infolist[NMol].intmin=1.0;
            infolist[NMol].intmax=-1.0;
            
          } 
          NMol=NMol-1;
          close(); // close molecular names&codes file
          open(Datafilename,ios::in); // open the data base file (!!!!)


                                             }  
virtual  void infooutput()
       { 
        for (int i=1; i<=NMol; i++)
          {
            if (infolist[i].nmbtr == 0) continue;
     printf("%s %7d %s", infolist[i].molecule,infolist[i].nmbtr," "); 
     printf("%12.6f %12.6f",infolist[i].fmin,infolist[i].fmax);
     printf("%10.3e %10.3e \n",infolist[i].intmin,infolist[i].intmax);
          }
       }      
      double power(char q)    // it calculates 10^(-q)
      {if (q==0) return 1;
       double q1=1;
       for (int i=1; i<=q; i++)
        { q1=10*q1;}
       q1=1.0/q1;
       return q1;
      }    
      
      virtual char criterium(char * ttt)
       { char m; double p,inten; short rint; char pint;
         memcpy(&p,ttt,8); // line position
         memcpy(&rint,ttt+8,2);
         memcpy(&pint,ttt+10,1);  
         inten=rint*power(pint); // line intensity
         memcpy(&m,ttt+60,1); // molecular code
         infolist[m].nmbtr++;
//         cout <<m<<endl;
         if (p < infolist[m].fmin) infolist[m].fmin=p;
         if (p > infolist[m].fmax) infolist[m].fmax=p;
         if (inten < infolist[m].intmin) infolist[m].intmin=inten;
         if (inten > infolist[m].intmax) infolist[m].intmax=inten;
                 
        return 0;
       }
       
       
       
                                    };
/*              ------------End of gsinfo class ---------------------------*/

/*          --------------- gstrs class -----------------------------------*/                                    
       
   class gstrs : public gsinfo {    
                                                
              protected:
                         char *  TrsIdent;
                         int     NmbTrs;  
                         int     NMolCodes;
                         short   MolCodes[MAXMOL];  
                         short * PMolCodes;    
                         int     Identlen;
                         struct trsinfo{ 
                              long   nmbtr;
                              float  fmin,fmax;
                              double intmin,intmax;
                              double sumint;
                                       } infotrs[MAXTRS];
         
              public:
    gstrs(int sz, char * nm1,char * molname,char * molliste,double from1, double to1):                                       
     gsinfo(sz,nm1,molname,from1,to1) {
         long maxtrs;
         NmbTrs=0;                                
         F1=from1;
         F2=to1;
         PMolCodes=MolCodes; // it points to MolCodes
         StrInts(PMolCodes,NMolCodes,molliste);
         Identlen=21;
         maxtrs=MAXTRS;
         long qmax=Identlen*maxtrs;
         TrsIdent=new char [qmax];
         if (TrsIdent == NULL) { cout << "Can not assign memory to TrsIdent" ;
                                 exit(1);
                                }
         for (int i=0; i<=MAXTRS; i++)
          { infotrs[i].nmbtr=0;
            infotrs[i].sumint=0;
            infotrs[i].fmin=1000000.0;
            infotrs[i].fmax=-1.0;
            infotrs[i].intmin=1.0;
            infotrs[i].intmax=-1.0;                                               
           } 
          
         
                                          }
                                                                 
          ~gstrs()
          {delete Bufer; delete TrsIdent; Fout.close();          }
          
     int number(char * idn)      
       { char control[21];
 
       for (int i=1; i<= NmbTrs;i++)
          { memcpy(control,TrsIdent+(i-1)*Identlen,Identlen);
            if (StrCmpn(idn,control,Identlen)==0) return i;
           }
       NmbTrs++;

       memcpy(TrsIdent+(NmbTrs-1)*Identlen,idn,Identlen);
     
       return NmbTrs;
       }     
             
     
     virtual char criterium (char * ttt) 
     { char m; double p,inten; short rint; char pint;
       char mist[3]; char vib[18]; char idd[21];
         if (MolCodes[0]==0) goto Next;
         memcpy(&m,ttt+60,1);
          for (int j=0; j<=NMolCodes-1;j++)
          {if (MolCodes[j]==int(m)) goto Next;}
         return 0; 
          
  Next:  
         memcpy(mist,ttt+58,3); // molecular code + isotope (binary characters)
   //      mist[3]='\0';
         memcpy(&p,ttt,8); // line position
         memcpy(&rint,ttt+8,2);
         memcpy(&pint,ttt+10,1);  
         inten=rint*power(pint); // line intensity
         memcpy(vib,ttt+21,18);
         
         memcpy(idd,mist,3);
         memcpy(idd+3,vib,18);
         int i=number(idd);
     
         infotrs[i].nmbtr++;
         infotrs[i].sumint=infotrs[i].sumint+inten;
//         cout <<m<<endl;
         if (p < infotrs[i].fmin) infotrs[i].fmin=p;
         if (p > infotrs[i].fmax) infotrs[i].fmax=p;
         if (inten < infotrs[i].intmin) infotrs[i].intmin=inten;
         if (inten > infotrs[i].intmax) infotrs[i].intmax=inten;
                 
        return 0;
     }         
         
          
virtual  void infooutput()
       { char m; short isot; char vib[18];
   //      cout <<"NmbTrs="<<NmbTrs<<endl;
        for (int i=1; i<=NmbTrs; i++)
          {memcpy(&m,TrsIdent+(i-1)*Identlen+2,1);
           memcpy(&isot,TrsIdent+(i-1)*Identlen,2);
           memcpy(vib,TrsIdent+(i-1)*Identlen+3,18);
           vib[18]='\0';
   //        cout <<int(m)<<" "<<isot<<" "<<vib<<endl;
     printf("%s %4d %s",infolist[m].molecule,isot,vib);
     printf("%7d %s", infotrs[i].nmbtr," "); 
     printf("%12.6f %12.6f",infotrs[i].fmin,infotrs[i].fmax);
     printf("%10.3E %10.3E %10.3E \n",infotrs[i].intmin,infotrs[i].intmax,infotrs[i].sumint);
    
          }
          
       }      
                
         
         
                              };     
 

              
              
                         