#include "mystrings_g.h"
#include "constants_g.h"

                struct trsinfo{
                              char   mol;
                              short  isotope;
                              long   nmbtr;
                              float  fmin,fmax;
                              double intmin,intmax;
                              double sumint;
                              char   vibr[18];
                                       };
   /* Ces fonctions sont pour trier "TRS"  */
      int compare (const void * a,const void * b)
     { //int mma,mmb;
       trsinfo ta,tb;
//       float fa,fb;
//       char ma,mb;
//       memcpy(&ma,(trsinfo*)a,1);
//       memcpy(&mb,(trsinfo*)b,1);
       memcpy(&ta,(trsinfo*)a,sizeof(trsinfo));
       memcpy(&tb,(trsinfo*)b,sizeof(trsinfo));

  //     mma=int(ma);
  //     mmb=int(mb);
//       cout <<mma<<" "<<mmb<<endl;
//       if ((ma-mb)>0 && (fa-fb)>0) return 1;
//       if ( ta.mol == tb.mol) return (int(ta.isotope-tb.isotope));
       return int(ta.fmin-tb.fmin);

     }


      int compare1 (const void * a,const void * b)
     { //int mma,mmb;
       trsinfo ta,tb;
       memcpy(&ta,(trsinfo*)a,sizeof(trsinfo));
       memcpy(&tb,(trsinfo*)b,sizeof(trsinfo));
       if (ta.mol != tb.mol) return int(ta.mol-tb.mol);
       return int(ta.fmin-tb.fmin);

     }
 /*                                  */

       double power(char q)    // it calculates 10^(-q)
      {if (q==0) return 1;
       double q1=1;
       for (int i=1; i<=q; i++)
        { q1=10*q1;}
       q1=1.0/q1;
       return q1;
      }


class datamenager: public ifstream {
 public:   long   Nentries;
           long   SizeofDatabase;
           long   Nmbextr;
 protected:
            int   DataSize, Nkeys;
           char * Datafilename;
           char * Bufer;
           char * Extrfilename;
        ofstream  Fout;
 public:
         datamenager(int,int,char *,char *); //constructor
//         datamenager(int,int,char *,char *,short );
         virtual void extr(long,long);
         virtual char criterium(char *);
         virtual void writedata(char *);



         ~datamenager();
                                   };

/*                       Members of datamenager            */

      datamenager::datamenager(int size,int key, char* name, char * outname) {
         long l,m; ldiv_t toto;

         Nmbextr=0;
         DataSize=size;
         Nkeys=key;
         Datafilename=name;
         Extrfilename=outname;
         Bufer= new char [DataSize];
         open(Datafilename,ios::in);
         if (! is_open())
             { cout << "Error opening database"; exit (1); }
         Fout.open(Extrfilename,ios::out);
         l=tellg();
         seekg(0,ios::end);
         m=tellg();
         SizeofDatabase=m-l;
         toto=ldiv(SizeofDatabase,DataSize);
         Nentries=toto.quot;
         seekg(0,ios::beg);  // do not forget !!!
                                                               }

    void  datamenager::extr(long a,long b) {

     if ((a < 1) || (b >Nentries)) { cout << "Extr procedure error"; exit(1);}
         seekg((a-1)*DataSize,ios::beg);
    for (long i=a; i<=b; i++)
      { read(Bufer,DataSize);

     if (criterium(Bufer)){ writedata(Bufer); Nmbextr++; }
      }


                                           }
    void  datamenager::writedata(char * Buf)
     {Fout.write(Buf,DataSize);}

    char  datamenager::criterium(char *) { return 1; }

       datamenager::~datamenager() { delete Bufer; Fout.close();}

 /*     ----- end of datamenager members  ------------------------------------ */
/*                                                        */
/*         Class gsmenager                               */
  class gsmenager : public datamenager {
  public:
          double F1,F2;   // from ... to (extraction)
          double First,Last;
          char   Form;
          short   MolCodes[MAXMOLISOT];
          short * PMolCodes;
          int    NMolCodes;
          int    NMol;
          char * Mfname;



  public:
          gsmenager(int sz,char * nm1,char * nm2,double from, double to1):
            datamenager(sz,11,nm1,nm2)
            { int l,m;
              F1=from;
              F2=to1;
              Form=0;  // format of output file: 0 -binary (default), 1- ASCII
              NMol=0;

              NMolCodes=0;
 /*       Searching for database spectral limits */
              seekg(0,ios::beg);
              read(Bufer,DataSize);
              memcpy(&First,Bufer,8);
              seekg((Nentries-1)*DataSize,ios::beg);
              read(Bufer,DataSize);
              memcpy(&Last,Bufer,8);
              close(); // close the database file

         open(Datafilename,ios::in); // open data base !!! do not forget !!
          }

          virtual char criterium(char * ttt)

          { // double freq;
             //memcpy(&freq,ttt,8);

            // return ((freq >=F1)&& (freq<=F2));
            return 1;
          }

          double frequency(long n)
            { double toto;
              seekg((n-1)*DataSize,ios::beg);
              read(Bufer,DataSize);
              memcpy(&toto,Bufer,8);
              return toto;
             }

          long poselement(double F)
          {
   //       if  ((F<First) || (F>Last))
    //        {
     //        cout << "Wavenumber is out of range: "<<First<<" - "<<Last ; exit(1); }
           if (F<First) return 1;
           if (F>Last) return Nentries;
           long left1=1;
           long right1=Nentries;
           long ncurrent=ldiv(right1+left1,2).quot;
           float delta=frequency(ncurrent)-F;
           long idelta=right1-left1;
           while (idelta !=1) {
            if (delta > 0.0)  right1=ncurrent;
                 else
                              left1=ncurrent;
           ncurrent=ldiv(right1+left1,2).quot;
           delta=frequency(ncurrent)-F;
           idelta=right1-left1;
                                          }
           double cfreq= frequency(ncurrent);
           if (cfreq > F2) ncurrent=ncurrent-1;
           if (cfreq <F1) ncurrent=ncurrent+1;
           return ncurrent;
          }

           void gextr()
         { extr(poselement(F1),poselement(F2)); }


  //       ~gsmenager()
   //      {delete Molliste;}

                                        };

   /*      ----- End of gsmenager class ----------*/
/*                                                          */


   /*         ---- Class extrallbands  ---------- */

    class extrallbands : public gsmenager {
      public:
   //               short MolCodes[MAXMOLISOT];
   //               int    NMolCodes;
      protected:

    //             short * PMolCodes;
                 char *  Criterium;
      public:


 extrallbands(int sz, char * nm1,char * nm2,double from1, double to1, char * crit1):
      gsmenager(sz,nm1,nm2,from1,to1)
   {
         Criterium=crit1;
         F1=from1;
         F2=to1;
         PMolCodes=MolCodes; // it points to MolCodes
         StrInts(PMolCodes,NMolCodes,Criterium);


    }

    virtual char criterium(char * ttt)
/*     Parameters in memcpy depend on format length! */
              { short mis,ist; char m;
                if (MolCodes[0]==0) return 1; // if mole='all'
                memcpy(&ist,ttt+63,2);  // 63, 65 for 127 bytes; 58, 60 - for 77 bytes
                memcpy(&m,ttt+65,1);
                mis=m*1000+ist;
                for (int i=0; i<=NMolCodes-1; i++)
                 {  if (MolCodes[i] <0)
                      if (m==-MolCodes[i]) return 1; // for molecules with all isotopes selected
                     if (MolCodes[i] > 0)
                      if (mis==MolCodes[i]) return 1;

                 }

                return 0;
               }
       void LesManip()
     { short mcopy[100];
       for (int i=0; i<=NMolCodes-1;i++)
         {if (MolCodes[i] > 1000) mcopy[i]=div(MolCodes[i],1000).quot;
                else mcopy[i]=MolCodes[i];
         }
         MolCodes[NMolCodes]=65500;
          for (int i=0; i<=NMolCodes-1;i++)
            { for (int j=i+1; j<=NMolCodes;j++)
                {
               if (mcopy[i] == mcopy[j]) goto brk;
                }
                if (i != 0)
                 if (mcopy[i-1]==mcopy[i]) goto brk;
               mcopy[i]=-mcopy[i];

          brk: continue;

            }
          for (int i=0; i<=NMolCodes-1; i++)
            {
               if (mcopy[i] <0) MolCodes[i]=-MolCodes[i];
            }

      }


                                         };



/*            ------------- gsinfo class ---------------------------------*/

    class gsinfo: public gsmenager {
        protected:
                   struct molinfo{
                      char molecule[MAXMOLNAMELENGTH];
                      long nmbtr;
                      float fmin,fmax;
                      double intmin,intmax;
                      double intaver;
                      float hwaver;
                                 } infolist[MAXMOL] ;

                    char * Molliste;
          //          int    NMol;
          //          char * Mfname;
         //           int    molnamelinesize; // 66 for UNIX, 67 for PC

        public:
     gsinfo(int sz,char * nm1,char * molname, double from1,double to1):
       gsmenager(sz,nm1,NULL,from1,to1) {
         char BBF[90];
         F1=from1;
         F2=to1;
         Mfname=molname;
         NMol=0;
  //       molnamelinesize=66; // 66 for UNIX, 67 for PC
         close(); // close the database file

   /*   Loading molecule names and initialization of counters   */

         open(Mfname,ios::in);
         if (! is_open())
             { cout << "Error opening molecular names&codes file"; exit (1); }
         while (! eof() )
          {
            getline(BBF,90);
            NMol++;
            memcpy(infolist[NMol].molecule,BBF,6);
            infolist[NMol].molecule[6]='\0';
            infolist[NMol].nmbtr=0;
            infolist[NMol].fmin=1000000.0;
            infolist[NMol].fmax=-1.0;
            infolist[NMol].intmin=1.0;
            infolist[NMol].intmax=-1.0;
            infolist[NMol].hwaver=0.0;
            infolist[NMol].intaver=0.0;

          }
          NMol=NMol-1;
          close(); // close molecular names&codes file
          open(Datafilename,ios::in); // open the data base file (!!!!)


                                             }
virtual  void infooutput()
       { float hwav; double intav;
        for (int i=1; i<=NMol; i++)
          {
            if (infolist[i].nmbtr == 0) continue;
     printf("%s %7d %s", infolist[i].molecule,infolist[i].nmbtr," ");
     hwav=infolist[i].hwaver/infolist[i].nmbtr;
     intav=infolist[i].intaver/infolist[i].nmbtr;
     printf("%10.3E %6.4f",intav,hwav);
     printf("%12.6f %12.6f",infolist[i].fmin,infolist[i].fmax);
     printf("%10.3E %10.3E \n",infolist[i].intmin,infolist[i].intmax);
          }
       }

      virtual char criterium(char * ttt)
 /*      Version adapted to GIDS format */
       { char m; double p,inten; short rint; char pint;short hw1;
         float hw;
         memcpy(&p,ttt,8); // line position
      //   memcpy(&rint,ttt+8,2);
      //   memcpy(&pint,ttt+10,1);
         memcpy(&inten,ttt+8,8);
         memcpy(&hw1,ttt+16,2);
         hw=hw1*0.0001;  //halfwidth
      //   inten=rint*power(pint+3); // line intensity
         memcpy(&m,ttt+65,1); // molecular code
         infolist[m].nmbtr++;
//         cout <<m<<endl;
         if (p < infolist[m].fmin) infolist[m].fmin=p;
         if (p > infolist[m].fmax) infolist[m].fmax=p;
         if (inten < infolist[m].intmin) infolist[m].intmin=inten;
         if (inten > infolist[m].intmax) infolist[m].intmax=inten;
         infolist[m].hwaver=infolist[m].hwaver+hw;
         infolist[m].intaver=infolist[m].intaver+inten;
        return 0;
       }



                                    };
/*              ------------End of gsinfo class ---------------------------*/

/*          --------------- gstrs class -----------------------------------*/

   class gstrs : public gsinfo {

              protected:
                         char *  TrsIdent;
                         int     NmbTrs;
                 //        int     NMolCodes;
         //                short   MolCodes[MAXMOL];
          //               short * PMolCodes;
                         int     Identlen;
                         trsinfo infotrs[MAXTRS];

              public:
    gstrs(int sz, char * nm1,char * molname,char * molliste,double from1, double to1):
     gsinfo(sz,nm1,molname,from1,to1) {
         long maxtrs;
         NmbTrs=0;
         F1=from1;
         F2=to1;
         PMolCodes=MolCodes; // it points to MolCodes
         StrInts(PMolCodes,NMolCodes,molliste);
         Identlen=21; // Attention !!!
         maxtrs=MAXTRS;
         long qmax=Identlen*maxtrs;
         TrsIdent=new char [qmax];
         if (TrsIdent == NULL) { cout << "Can not assign memory to TrsIdent" ;
                                 exit(1);
                                }
         for (int i=0; i<=MAXTRS; i++)
          { infotrs[i].nmbtr=0;
            infotrs[i].sumint=0;
            infotrs[i].fmin=1000000.0;
            infotrs[i].fmax=-1.0;
            infotrs[i].intmin=1.0;
            infotrs[i].intmax=-1.0;
           }


                                          }

          ~gstrs()
          {delete Bufer; delete TrsIdent; Fout.close();          }

     int number(char * idn)
       { char control[21]; char m; short isot;


    //     memcpy(&m,idn+2,1);
    //     memcpy(&isot,idn,2);
    //     cout <<"mol="<<int(m)<<" "<<"isot="<<isot<<endl;

       for (int i=1; i<= NmbTrs;i++)
          { memcpy(control,TrsIdent+(i-1)*Identlen,Identlen);
            if (StrCmpn(idn,control,Identlen)==0) return i;
          }
       NmbTrs++;

       memcpy(TrsIdent+(NmbTrs-1)*Identlen,idn,Identlen);



       return NmbTrs;
       }


     virtual char criterium (char * ttt)
     { char m; double p,inten; short rint; char pint;
       char mist[3]; char vib[18]; char idd[21];
       short isot;
         if (MolCodes[0]==0) goto Next;
         memcpy(&m,ttt+65,1);
          for (int j=0; j<=NMolCodes-1;j++)
          {if (MolCodes[j]==int(m)) goto Next;}
         return 0;

  Next:
         memcpy(mist,ttt+63,3); // molecular code + isotope (binary characters)
   //      mist[3]='\0';
         memcpy(&p,ttt,8); // line position
   //      memcpy(&rint,ttt+8,2);
   //      memcpy(&pint,ttt+10,1);
   //      inten=rint*power(pint+3); // line intensity
         memcpy(&inten,ttt+8,8);
         memcpy(vib,ttt+26,18);    // vibrational identification;
         vib[18]='\0';

         memcpy(idd,mist,3);
         memcpy(idd+3,vib,18);

         int i=number(idd)-1;
         memcpy(&m,ttt+65,1); //??
         memcpy(&isot,ttt+63,2);
         infotrs[i].mol=int(m);
         infotrs[i].isotope=isot;
         memcpy(infotrs[i].vibr,vib,19);
         infotrs[i].nmbtr++;
         infotrs[i].sumint=infotrs[i].sumint+inten;
//         cout <<m<<endl;
         if (p < infotrs[i].fmin) infotrs[i].fmin=p;
         if (p > infotrs[i].fmax) infotrs[i].fmax=p;
         if (inten < infotrs[i].intmin) infotrs[i].intmin=inten;
         if (inten > infotrs[i].intmax) infotrs[i].intmax=inten;

        return 0;
     }


virtual  void infooutput()
       {



       char m; short isot; char vib[18];
       char Buff0[256];
       ifstream fmolisot("molisot.txt");
       if ( ! fmolisot.is_open())
           { cout << "Error opening molisot.txt file"; exit(1); }
       ifstream fmolident("molident.txt"    );
       if ( ! fmolident.is_open())
           { cout << "Error opening molident.txt file"; exit(1); }

   //       cout <<"NmbTrs="<<NmbTrs<<endl;
   //      qsort(infotrs,NmbTrs,sizeof(trsinfo),compare);
           qsort(infotrs,NmbTrs,sizeof(trsinfo),compare1);

   //      qsort(TrsIdent,NmbTrs,21,compare1);
         char mold=0; long nntrs=0; long ntotal=0;
         Identlen=21;
//         NmbTrs=NmbTrs-1;
        int inum=0;
        cout <<"                EXTRACTION OF THE FOLLOWING MOLECULES AND ISOTOPES: "<<endl;
        cout <<"  Mole ID      isotope identifications [Ref.1] "<<endl;
        cout <<" "<<endl;
    //    cout <<" "<<endl;

       if (PMolCodes[0] ==0)
         { while (! fmolisot.eof())
             {fmolisot.getline(Buff0,250);
               cout << Buff0<<endl;
             }
                fmolisot.seekg(0,ios::beg);
                  goto Lab4;

         }

        for (int ia=0; ia < NMolCodes; ia++)
         {
         // cout <<infolist[PMolCodes[ia]].molecule<<endl;
         while (! fmolisot.eof())
             {fmolisot.getline(Buff0,250);
              if (StrFind(Buff0,infolist[PMolCodes[ia]].molecule) !=0)
               {  //int iilen=strlen(infolist[PMolCodes[ia]].molecule);
                  //if (Buff0[iilen+1]==' ')
                  // {
                  cout << Buff0<<endl;
                  fmolisot.seekg(0,ios::beg);
                  goto Lab1;
                  //  }
               }
             }
         Lab1:
           //   cout << infolist[PMolCodes[ia]].molecule<<endl;
              continue;
         }
    Lab4:     cout <<"   "<<endl;
        cout <<"1. N.Jacquinet-Husson et al., 'The 1997 spectroscopic GEISA databank', JQSRT, v. 62, p.p. 205-254 (1999)"<<endl;
        cout <<"   "<<endl;

     while (! fmolident.eof())
             {fmolident.getline(Buff0,250);
              if (StrFind(Buff0,infolist[infotrs[0].mol].molecule) !=0)
               {
                  cout <<int(infotrs[0].mol)<<") "<<Buff0<<endl;
                  cout <<"     ***************************"<<endl;
                  fmolident.seekg(0,ios::beg);
                  goto Lab3;

               }
             }
    Lab3:
      cout <<"--------------------------------------------------------------------------------------------------------"<<endl;
      cout <<"          Mol  Isot         vib ident  #lines    nu.min.       nu.max.    min.i.     max.i.    sum.i."<<endl;
      cout <<"                        E'       E''             (cm-1)        (cm-1)   (cm mol-1) (cm mol-1) (cm mol-1)"<<endl;
      cout <<"--------------------------------------------------------------------------------------------------------"<<endl;

        for (long i=0; i< NmbTrs; i++)
         {
       /*    memcpy(&m,TrsIdent+i*Identlen+2,1);
           memcpy(&isot,TrsIdent+i*Identlen,2);
           memcpy(vib,TrsIdent+i*Identlen+3,18);
           vib[18]='\0';
           cout <<int(m)<<" "<<isot<<" "<<vib<<endl;
       */
           m=infotrs[i].mol;
        if (m != mold) {
          printf("%s \n","           ");
          mold=m;
          inum=0;
          if (i != 0) { cout <<" Number of transitions: "<<nntrs<<endl;
          nntrs=0;
          printf("%s \n","           ");

          while (! fmolident.eof())
             {fmolident.getline(Buff0,250);
              if (StrFind(Buff0,infolist[m].molecule) !=0)
               {
                  cout <<int(m)<<") "<< Buff0<<endl;
                  cout <<"     ***************************"<<endl;
                  fmolident.seekg(0,ios::beg);
                  goto Lab2;

               }
             }
      Lab2:
      cout <<"--------------------------------------------------------------------------------------------------------"<<endl;
      cout <<"          Mol  Isot         vib ident  #lines    nu.min.       nu.max.    min.i.     max.i.    sum.i."<<endl;
      cout <<"                        E'       E''             (cm-1)        (cm-1)   (cm mol-1) (cm mol-1) (cm mol-1)"<<endl;
      cout <<"--------------------------------------------------------------------------------------------------------"<<endl;

                        }
                        }
     nntrs=nntrs+infotrs[i].nmbtr;
     ntotal=ntotal+infotrs[i].nmbtr;
     inum++;
     printf("%4d %s %s %4d %s",inum,")",infolist[m].molecule,infotrs[i].isotope,infotrs[i].vibr);
     printf("%7d %s", infotrs[i].nmbtr," ");
     printf("%12.6f %12.6f",infotrs[i].fmin,infotrs[i].fmax);
     printf("%10.3E %10.3E %10.3E \n",infotrs[i].intmin,infotrs[i].intmax,infotrs[i].sumint);

          }
     printf("%s \n","     ");
     cout <<" Number of transitions: "<<nntrs<<endl; //for last molecule
     printf("%s \n","     ");
     cout <<"Total number of transitions for this extraction in the spectral range "<<F1<<" - "<<F2<<" cm-1: "<<ntotal<<endl;
     cout <<"   "<<endl;
     cout <<"**********************************************************"<<endl;
     cout <<"E'      - upper level vibrational quantum numbers"<<endl;
     cout <<"E''     - lower level vibrational quantum numbers"<<endl;
     cout <<"isot    - isotope identification (see reference 1)"<<endl;
     cout <<"#lines  - number of spectral lines for the actual vibrational band"<<endl;
     cout <<"nu.min. - lower wavenumber for the actual vibrational band"<<endl;
     cout <<"nu.max. - upper wavenumber for the actual vibrational band"<<endl;
     cout <<"min.i.  - minimum intensity within the actual vibrational band"<<endl;
     cout <<"max.i.  - maximum intensity within the actual vibrational band"<<endl;
     cout <<"sum.i.  - sum of intensities of the actual vibrational band"<<endl;
      fmolisot.close();
      fmolident.close();

       }



                              };

/*               ---------- End of gstrs class ------------------------ */

/*             --------------- gslst class ------------------------- */

class gslst : public extrallbands {

 protected:
               char *  Trs1;
               char *  Trs2;
               char   Transition[37];
               char * MolNames;
               char   Gident[256];
               int    Ngscodes;
               char   Molnm[MOLNAMELEN];



 public:       gslst(int sz,char * nm1,char * nm2,char * nmgsi,double from1, double to1,char * crit1,char * t1, char * t2):
     extrallbands(sz,nm1,NULL,from1,to1,crit1){
                 F1=from1;
                 F2=to1;
                 Trs1=t1;
                 Trs2=t2;
                 Mfname=nm2;
                 Ngscodes=0;
                 close(); // close the database file
   /*   Loading molecule names    */
         MolNames= new char[MAXMOL*7];
         open(Mfname,ios::in);
         if (! is_open())
             { cout << "Error opening molecular names&codes file"; exit (1); }
         while (! eof() )
          {
            getline(Bufer,100);
            NMol++;
            if (NMol > MAXMOL) { cout <<"Number of molecules is greater than MAXMOL parameter in constants.h";
                                 exit(1);
                               }
            memcpy(MolNames+(NMol-1)*MOLNAMELEN,Bufer,MOLNAMELEN);
//          MolNames[NMol*MOLNAMELEN]='\0';

          }
          NMol=NMol-1; // ???
  //        for (int qi=0;qi<NMol; qi++)
  //         {
  //          cout <<MolNames+qi*MOLNAMELEN<<" "<<qi<<endl;
  //         }
          close(); // close molecular names&codes file
          open(nmgsi,ios::in); //open GEISA internal identification codes file
          if (! is_open())

             { cout << "Error opening GEISA internal identification codes file"; exit (1); }

         while (! eof() )

          {
           getline(Bufer,20);
           if (Ngscodes > 64) { cout << "Number of GEISA internal identification codes has to be <=64"; exit (1); }
           memcpy(Gident+Ngscodes*4,Bufer,4);
           Ngscodes++;
          }
          close(); //close GEISA internal identifications file

           open(Datafilename,ios::in); // open the data base file (!!!!)

                                              }

        virtual char criterium(char * ttt)
    /* for GIDS format */
                                            {
         char V1[10];
         char V2[10];
         double p,inten,enlow;
         short rint,isot00;
         char pint,pp,m;
         float hw,tcf;
         int mol;
         char ggg[3];
         memcpy(&isot00,ttt+63,2);       //isotope
         memcpy(&m,ttt+65,1);
         mol=int(m);                   //molecule code
         int qcm=mol*1000+isot00;
           for (int j=0; j<NMolCodes;j++)
            {
              if (qcm !=MolCodes[j]) continue;
              goto Lab1;
            }
         return 0;

   Lab1: memcpy(Transition,ttt+26,36); //transition identification
         Transition[36]='\0';
         StrCopy(V1,Transition,0,8);   //upper vibrational
         StrCopy(V2,Transition,9,17);  //lower vibrational
         if (StrFind(V1,Trs1)==0) return 0;
         if (StrFind(V2,Trs2)==0) return 0;
         memcpy(&p,ttt,8); // line position
     //    memcpy(&rint,ttt+8,2);
     //    memcpy(&pint,ttt+10,1);

     //    inten=rint*power(pint+3);  // line intensity
         memcpy(&inten,ttt+8,8);
         memcpy(&rint,ttt+16,2);
         hw=rint/10000.0;              //halfwidth
         memcpy(&enlow,ttt+18,8);      //energy of low level
         memcpy(&pint,ttt+62,1);
         tcf=int(pint)/100.0;        //temperature coefficient
         memcpy(&pint,ttt+66,1);

         for (int i=0;i<Ngscodes;i++)
          {
            memcpy(&pp,Gident+i*4,1);
             if (pp !=pint) continue;
            memcpy(ggg,Gident+i*4+1,3);
            ggg[3]='\0';               //GEISA internal identification
            goto Next;
          }
         strcpy(ggg,"-?-");
     Next:
     Nmbextr++;
      /*   Output listing to StdOut   */
        printf("%12.6f %10.3E %6.4f %10.4f",p,inten,hw,enlow);
        printf("%s %4.2f %3d %4d %s %s \n", Transition,tcf,mol,isot00,Molnm,ggg);
         return 0;
                                           }

virtual  void infooutput()
{
 memcpy(Molnm,MolNames+(div(MolCodes[1],1000).quot-1)*MOLNAMELEN,MOLNAMELEN);
 Molnm[MOLNAMELEN]='\0';
 short isot00=div(MolCodes[1],1000).rem;


cout <<"                                CONSULTATION OF GEISA DATABASE CONTENTS"<<endl;
printf("%s \n"," ");
cout <<"SPECTRAL INTERVAL (CM-1) NU1="<<F1<<"  NU2="<<F2<<endl;
printf("%s \n"," ");
cout <<"VIBRATION-ROTATION TRANSITIONS INVOLVED IN THE TRANSITION";
cout <<" "<<Trs1<<"  "<<Trs2<<endl;
cout <<"OF THE MOLECULE "<<Molnm<<"/ ISOTOPE "<<isot00 <<endl;
printf("%s \n"," ");
printf("%s \n","                                  (a)  wavenumber (cm-1)  ");
printf("%s \n","                                  (b)  intensity (cm molec-1 at 296 k) ");
printf("%s \n","                                  (c)  collision halfwidth (cm-1 atm-1) ");
printf("%s \n","                                  (d)  energy of the lower level of the trasition (cm-1)");
printf("%s \n","                                  (e)  identification of the transition ");
printf("%s \n","                                  (f)  coefficient for temperature dependence of halfwidth");
printf("%s \n","                                  (g)  identification of the isotope ");
printf("%s \n","                                  (h)  identification of the molecule ");
printf("%s \n","                                  (i)  molecule name ");
printf("%s \n","                                  (j)  internal GEISA code for data origination ");
printf("%s \n","  ");
printf("%s \n","------------------------------------------------------------------------------------------------------");
printf("%s \n","|  (a)      |   (b)   |  (c)  |  (d)     |               (e)                  |(f)|(g) | (h)| (i)|(j)|");
printf("%s \n","------------------------------------------------------------------------------------------------------");


}





         ~gslst() {delete Bufer; delete MolNames;}







                              };

/*               ---------- End of gslst class ------------------------ */

