#include <fstream.h>
#include <string.h>
#include "mystrings.h"

/*   Search new and the same vibrational bands in NewFile in comparation with OldFile. 
     Put lines from new bands in Newlines.
     Put the same lines in TheSamelines.
     All files are in GEISA "new" ASCII format !
     Palaiseau- LMD, 27 December 2000.
*/
long SizeNew,SizeOld;
long NNew,NOld;
char * BufNew;
char * BufOld;
ofstream Fout,Fsame;
const int EntrySize=121; // 122 for PC
long NNewLines;
long SameLines;

    void compare()
 {  char IdentNew[46];
    char IdentOld[66];
    char MistNew[10];
    char MistOld[10];

    NNewLines=0;
    SameLines=0;
    for (long i=0; i<NNew; i++)
     {
       StrCopy(IdentNew,BufNew+i*EntrySize,38,55);
       StrCopy(MistNew,BufNew+i*EntrySize,78,83);
//       cout <<"IdNew1:"<<IdentNew<<endl;
//       cout <<"MNew1:"<<MistNew<<endl;

       if (div(i,100).rem ==0) {
          cout <<i<<" lines processed"<<endl;
          cout <<NNewLines<<" new lines and ";
          cout <<SameLines<<" the same lines have been found"<<endl;
                                }
      for(long j=0; j<NOld; j++)
       {
       StrCopy(IdentOld,BufOld+j*EntrySize,38,55);
       StrCopy(MistOld,BufOld+j*EntrySize,78,83);

/*       cout <<"IdNew:"<<IdentNew<<endl;
       cout <<"IdOld:"<<IdentOld<<endl;
       printf("%s \n","    ");
       cout <<"MNew:"<<MistNew<<endl;
       cout <<"MOld:"<<MistOld<<endl;

*/
       if (( StrCmpn(IdentNew,IdentOld,18)==0) && (StrCmpn(MistNew,MistOld,6)==0)) goto Next;
       }
      NNewLines++;
      Fout.write(BufNew+i*EntrySize,EntrySize);
      continue;

 Next: Fsame.write(BufNew+i*EntrySize,EntrySize);
       SameLines++;
     }

 }
  int main () {
  char Newfile[]="no_g97.g00";
  char Oldfile[]="no_h96.g00";
//  char Newfile[]="toto.2";
//  char Oldfile[]="toto2";
  char NewLines[]="g97_newbands.no";
  char TheSamelines[]="g97-h96_thesamebands.no";
/*  char IdentOld[66];
  char MistOld[10];
  char IdentNew[66];
  char MistNew[10];
*/
  long l,m;
  // Load Newfile

  ifstream Nfile(Newfile,ios::in|ios::binary);
  l=Nfile.tellg();
  Nfile.seekg(0,ios::end);
  m=Nfile.tellg();
  SizeNew=m-l;
  NNew=ldiv(SizeNew,EntrySize).quot;
  BufNew= new char [SizeNew];
  if (BufNew == NULL) { cout <<"Can not allocate memory for BufNew"<<endl; exit(1); }
  Nfile.seekg(0,ios::beg);
  Nfile.read(BufNew,SizeNew);
  Nfile.close();
  cout <<"NewFile is into the memory! Its size: "<<SizeNew<<" bytes, "<<NNew<<" entries"<< endl;
/*
      for(long j=0; j<NNew; j++)
       {
       StrCopy(IdentNew,BufNew+j*EntrySize,38,73);
       StrCopy(MistNew,BufNew+j*EntrySize,78,83);
//       cout <<BufOld<<endl;
       cout <<"IdNew:"<<IdentNew<<endl;
       cout <<"MNew:"<<MistNew<<endl;

       }

*/
  // Load OldFile
  ifstream Ofile(Oldfile,ios::in|ios::binary);
  l=Ofile.tellg();
  Ofile.seekg(0,ios::end);
  m=Ofile.tellg();
  SizeOld=m-l;
  NOld=ldiv(SizeOld,EntrySize).quot;
  BufOld= new char [SizeOld];
  if (BufOld == NULL) { cout <<"Can not allocate memory for BufOld"<<endl; exit(1); }
  Ofile.seekg(0,ios::beg);
  Ofile.read(BufOld,SizeOld);
  Ofile.close();
  cout <<"OldFile is into the memory! Its size: "<<SizeOld<<" bytes, "<<NOld<<" entries"<< endl;
/*      for(long j=0; j<NOld; j++)
       {
       StrCopy(IdentOld,BufOld+j*EntrySize,38,73);
       StrCopy(MistOld,BufOld+j*EntrySize,78,83);
//       cout <<BufOld<<endl;
       cout <<"IdOld:"<<IdentOld<<endl;
       cout <<"MOld:"<<MistOld<<endl;

       }
*/

  Fout.open(NewLines,ios::out);
  Fsame.open(TheSamelines,ios::out);
  compare();
  Fout.close();
  Fsame.close();
  delete BufNew;
  delete BufOld;
  cout<<"            "<<endl;
  cout <<"Program terminated. "<<NewLines<<" file contains " <<NNewLines <<" new lines";
  cout <<" and "<<SameLines<<" the same lines"<<endl;
  return 0;
              }

