unit aeros;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TEditPtr=^TEdit;
  TTFile= array[1..15] of Text;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    RunButton: TButton;
    ClearButton: TButton;
    Label3: TLabel;
    Reference: TLabel;
    FromLine: TEdit;
    ToLine: TEdit;
    C1: TEdit;
    C2: TEdit;
    C3: TEdit;
    C4: TEdit;
    C5: TEdit;
    C6: TEdit;
    NComp: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    Button3: TButton;
    C7: TEdit;
    C8: TEdit;
    C9: TEdit;
    C10: TEdit;
    C11: TEdit;
    C12: TEdit;
    Constructor Init;
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure RunButtonClick(Sender: TObject);
    function DEmelanger:Boolean;
    procedure ReadReal;
    procedure ReadImaginary;
    procedure AddNentries(Nc,N: Integer);

    procedure NColumnsEnter(Sender: TObject);
    procedure NCompClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);


  private
    { Private declarations }
     TargetFile, SourceFile        : String;
     HeaderFile                    : String;
     Ncol, RealLine, ImaginaryLine : Integer;
     LaReference                   : String;
     ComponentName                 : String;
     MaxComp                       : Byte;
     CPoint                        : Array[1..15] of TEditPtr;
     Concentr                      : Array[1..15] of Integer;
     FSource, FHeader, FTarget     : Text;
     FImagHeader                   : Text; 
     StrTemp                       : String[3];
     FFiles                        : Array[1..15] of File;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Procedure TForm1.ReadReal;
var
     I,J,JJ       : Integer;
     cm,micr      : Real;
     Ftar         : TTFile;
     StrConc      : String[5];
     HBuf         : String;
     StrNentries  : String[7];
     cc           : String[7];  //it was 6 for Biermann
     ctwo         : String[2]; 
Begin
    // StrTemp:='293'; // for data by Palmer and Williams
     for j:=1 to Ncol do Begin
       StrConc:=CPoint[j]^.Text;
       System.Assign(Ftar[j],SourceFile+'.C'+StrConc+'.R');
       Rewrite(Ftar[j]);
       // Reading the header file.
       Reset(FHeader);
       for jj:=1 to 2 do Begin
           Readln(FHeader,HBuf);
           Writeln(Ftar[j],HBuf);
                         End;
       Readln(FHeader,HBuf);
       Write(Ftar[j],HBuf,' ',StrConc,'% ');
       Readln(FHeader,HBuf);
       Write(Ftar[j],HBuf,' ',StrTemp,'K ');
       jj:=ImaginaryLine-RealLIne-3;
       Str(jj,StrNentries);
       Writeln(Ftar[j],'#entries ',StrNentries);
       for jj:=1 to 5 do Begin
           Readln(FHeader,HBuf);
           Writeln(Ftar[j],HBuf);
                         End;
                         End;
     for j:=1 to RealLine-1 do Readln(Fsource);
     for j:=RealLine to ImaginaryLine-4 do Begin
       Read(Fsource, cm,micr); // added ctwo for Palmer
       for i:=1 to Ncol do Begin
                           read(Fsource, CC);
                          writeln(Ftar[i],cm:10:2,micr:12:4,CC:7);   //it was cc:6 for Biermann
                           End;
       Readln(Fsource);

                                           End;
        for j:=1 to Ncol do System.Close(Ftar[j]);
End;

Procedure TForm1.AddNentries (Nc,N:Integer);
var
     I, J       : Integer;
     StrN       : String[12];
     Pos1,Pos2  : Longint;



Begin
//  Position for #entries:
  Pos1:=185;   //189 for H2SO4
//  Position for Imaginary:
  Pos2:=249;
I:=0;
Str(N,StrN);
Seek(FFiles[Nc],Pos1);
BlockWrite(FFiles[nc],StrN[1],Length(StrN));
{StrN:='Imaginary';
Seek(FFiles[nc],Pos2);
BlockWrite(FFiles[nc],StrN[1],Length(StrN)); }

End;


Procedure TForm1.ReadImaginary;
var
     I,J,JJ       : Integer;
     cm,micr      : Real;
     Ftar         : TTFile;
     StrConc      : String[5];
     HBuf         : String;
     StrNentries  : String[7];
     Nimg         : Array[1..15] of Integer;
     cc           : String[11]; //it was 10 for Biermann
     ctwo         : String[2];
Begin
     for j:=1 to 15 do Nimg[j]:=0;
     for j:=1 to Ncol do Begin
       StrConc:=CPoint[j]^.Text;
       System.Assign(Ftar[j],SourceFile+'.C'+StrConc+'.I');
       Rewrite(Ftar[j]);
       // Reading the header file for Imaginary data
       Reset(FImagHeader);
       for jj:=1 to 2 do Begin
           Readln(FImagHeader,HBuf);
           Writeln(Ftar[j],HBuf);
                         End;
       Readln(FImagHeader,HBuf);
       Write(Ftar[j],HBuf,' ',StrConc,'% ');
       Readln(FImagHeader,HBuf);
       Write(Ftar[j],HBuf,' ',StrTemp,'K #entries      ');
       //jj:=ImaginaryLine-RealLIne-3;
       //Str(jj,StrNentries);
       Writeln(Ftar[j]);
       for jj:=1 to 5 do Begin
           Readln(FImagHeader,HBuf);
           if (JJ <> 3) then Writeln(Ftar[j],HBuf)
                        else Writeln(Ftar[j],HBuf,'     ');
                         End;
                         End;
     for j:=1 to ImaginaryLine-1 do Readln(Fsource);
     //for j:=RealLine to ImaginaryLine-4 do Begin
     While not Eof(Fsource) do Begin
       Read(Fsource, cm,micr);
       for i:=1 to Ncol do Begin
                           read(Fsource, CC);
                           if (cc <> '  0.000E+00') then Begin
                           writeln(Ftar[i],cm:10:2,micr:12:4,CC:11);
                           Nimg[i]:=Nimg[i]+1;
                                             End;
                           End;
       Readln(Fsource);

                                           End;
        for j:=1 to Ncol do System.Close(Ftar[j]);
// Open output Imaginary files as untyped files
        for j:=1 to Ncol do Begin
       StrConc:=CPoint[j]^.Text;
       System.Assign(Ffiles[j],SourceFile+'.C'+StrConc+'.I');
       Reset(FFiles[j],1);
       AddNentries(j,Nimg[j]);
       System.Close(FFiles[j]);
                         End;

End;

Function TForm1.Demelanger:Boolean;
    var
     Code,i        : Integer;
     LesDonnees    : Array [1..20] of Real;
begin

       Demelanger:=False;
       Val(FromLine.Text, RealLine,Code);
        if Code <> 0 then  Begin
    MessageDlg('Invalid First Real Data Line number !', mtWarning, [mbOk], 0);
    Exit;
                           End;
       Val(ToLine.Text,ImaginaryLine,Code);
        if Code <> 0 then  Begin
    MessageDlg('Invalid First Imaginary Data Line number !', mtWarning, [mbOk], 0);
    Exit;
                           End;
     // Temperature
      StrTemp:=System.Copy(SourceFile,Pos('.',SourceFile)-3,3);
     //
     System.Assign(FSource,SourceFile);
     Reset(FSource);
     System.Assign(FHeader,HeaderFile);
     Reset(FHeader);
      ReadReal;
     Reset(FSource);
     System.Assign(FImagHeader,HeaderFile+'.im');
     Reset(FImagHeader);
      ReadImaginary; 
     Demelanger:=True;
     System.Close(Fsource);
     System.Close(Fheader);
         End;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Halt(0);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
   With OpenDialog1 do
      If Execute then Begin
                        SourceFile:=FileName;
                        Label1.Caption:='Source: '+SourceFile;
                        RunButton.Enabled:=True;
                        NComp.Enabled:=True;
                      End;
end;

procedure TForm1.ClearButtonClick(Sender: TObject);
begin
                        SourceFile:='';
                        Label1.Caption:='Source: ';
                        Label4.Caption:='Header: ';
                        RunButton.Enabled:=False;
                        Button3.Enabled:=False;
                        NComp.Enabled:=False;
                        NComp.Text:='1';
                        FromLine.text:='0';
                        ToLine.text:='0';

end;

procedure TForm1.RunButtonClick(Sender: TObject);
 var
     Code : Integer;
begin
       Val(NComp.Text, NCol,Code);

    if Demelanger then
    MessageDlg('A L L  D O N E !', mtInformation, [mbOk], 0);

end;
Constructor Tform1.Init;
Begin
MaxComp:=6;
CPoint[1]:=Addr(C1);
CPoint[2]:=@C2;
CPoint[3]:=@C3;
CPoint[4]:=@C4;
CPoint[5]:=@C5;
CPoint[6]:=@C6;
end;


procedure TForm1.NColumnsEnter(Sender: TObject);
var i,Code: Integer;
begin
{ Val(NColumns.Text, NCol,Code);
        if Code <> 0 then
    MessageDlg('Invalid number of columns!', mtWarning, [mbOk], 0)
                     else
           for i:=1 to Ncol do
                                Begin
                           CPoint[i]^.Visible:=True;
                                End;  }

end;

procedure TForm1.NCompClick(Sender: TObject);
var i, Code: Integer;
begin
MaxComp:=12;
CPoint[1]:=Addr(C1);
CPoint[2]:=@C2;
CPoint[3]:=@C3;
CPoint[4]:=@C4;
CPoint[5]:=@C5;
CPoint[6]:= @C6;
CPoint[7]:= @C7;
CPoint[9]:= @C9;
CPoint[10]:= @C10;
CPoint[11]:= @C11;
CPoint[8]:= @C8;
CPoint[12]:= @C12;
Val(NComp.Text,Ncol,Code);
     for i:=1 to Ncol do
                                Begin
                           CPoint[i]^.Visible:=True;
                                End;
If (Ncol <> MaxComp) then for i:=Ncol+1 to MaxComp do
                                Begin
                           CPoint[i]^.Visible:=False;
                                End;


end;

procedure TForm1.Button1Click(Sender: TObject);
begin
            With OpenDialog1 do
      If Execute then Begin
                        SourceFile:=FileName;
                        Label1.Caption:='Source: '+SourceFile;
                        Button3.Enabled:=True;

                      End;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    If ( MessageDlg('Are you sure you want to quit?',
             mtConfirmation, [mbOk, mbCancel], 0)= mrOk) then Halt;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
       
            With OpenDialog1 do
      If Execute then Begin
                        HeaderFile:=FileName;
                        Label4.Caption:='Header: '+HeaderFile;
                        RunButton.Enabled:=True;
                        NComp.Enabled:=True;
                      End;
end;

end.
